using OfficeOpenXml;
using System.Data.SQLite;
using System.Diagnostics;

namespace AsmrManage
{
    public partial class Form1 : Form
    {
        public Form1() //init
        {
            InitializeComponent();
        }


        private void Button1_Click(object sender, EventArgs e) //P2 xlsxļѡ
        {
            OpenFileDialog openFileDialog1 = new OpenFileDialog();
            openFileDialog1.Title = "ѡϵxlsxļ";
            openFileDialog1.InitialDirectory = Environment.GetFolderPath(Environment.SpecialFolder.Desktop);
            openFileDialog1.Filter = "Excelļ|*.xlsx|ļ|*.*";
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                textBox1.Text = openFileDialog1.FileName;
            }

        }

        private void Button2_Click(object sender, EventArgs e) //P2 dbļλѡ
        {
            FolderBrowserDialog folderBrowserDialog1 = new FolderBrowserDialog();
            folderBrowserDialog1.UseDescriptionForTitle = true;
            folderBrowserDialog1.Description = "ѡ񱣴λ";
            if (folderBrowserDialog1.ShowDialog() == DialogResult.OK)
            {
                textBox2.Text = folderBrowserDialog1.SelectedPath;
            }
        }

        private void Log(string message) //xlsx2db log function
        {
            logBox1.AppendText(message + Environment.NewLine);
            logBox1.ScrollToCaret();
        }

        private void Button3_Click(object sender, EventArgs e) //xlsx2db ʼ
        {
            Log("ʼ");
            string excelFilePath = textBox1.Text;
            string? databaseLocation;
            if (checkBox2.Checked)
            {
                databaseLocation = Path.GetDirectoryName(excelFilePath);
            }
            else
            {
                databaseLocation = textBox2.Text;
            }

            if (string.IsNullOrEmpty(excelFilePath) || string.IsNullOrEmpty(databaseLocation))
            {
                Log("TextBox1  TextBox2 Ϊգ޷");
                return;
            }
            string databaseFileName = "asmr.db";
            string databasePath = Path.Combine(databaseLocation, databaseFileName);
            Log($"Դļ:{excelFilePath}\nļ:{databasePath}");
            FileInfo fileInfo = new FileInfo(excelFilePath);

            string? password = null;

            if (checkBox4.Checked)// ļ뱣
            {
                Log("ļ뱣");
                password = textBox3.Text;
            }

            if (!File.Exists(databasePath))
            {
                Log("ĿDBļڣ׼");
                SQLiteConnection.CreateFile(databasePath);
            }
            else
            {
                if (checkBox1.Checked) //allow override
                {
                    Log("ļѴڣ15s󸲸Ѵڵļ練뼰ʱ");
                    Task.Delay(15000).Wait(); // ʱ15
                    File.Delete(databasePath);
                    SQLiteConnection.CreateFile(databasePath);
                }
                else
                {
                    Log("ļѴڣǰ趨ļ˳");
                    return;
                }
            }

            string connectionString = $"Data Source={databasePath};Version=3;";

            Task.Run(() =>
            {
                try
                {
                    using (ExcelPackage package = new ExcelPackage(fileInfo, password))
                    {
                        using (SQLiteConnection connection = new SQLiteConnection(connectionString))
                        {
                            connection.Open();

                            foreach (var worksheet in package.Workbook.Worksheets)
                            {
                                string tableName = worksheet.Name;
                                BeginInvoke((Action)(() =>
                                {
                                    Log($"ʼ{tableName}");
                                }));


                                // һ洢
                                string createTableQuery = $"CREATE TABLE IF NOT EXISTS {tableName} (asmr_id TEXT, asmr_order_id INTEGER)";
                                using (SQLiteCommand command = new SQLiteCommand(createTableQuery, connection))
                                {
                                    command.ExecuteNonQuery();
                                }

                                int rowCount = worksheet.Dimension.Rows;

                                for (int row = 2; row <= rowCount; row++) // ӵڶпʼһǱͷ
                                {
                                    string? asmr_id = worksheet.Cells[row, 1].Value?.ToString();
                                    int asmr_order_id = Convert.ToInt32(worksheet.Cells[row, 2].Value);

                                    string insertDataQuery = $"INSERT INTO {tableName} (asmr_id, asmr_order_id) VALUES (@asmr_id, @asmr_order_id)";

                                    using (SQLiteCommand insertCommand = new SQLiteCommand(insertDataQuery, connection))
                                    {
                                        insertCommand.Parameters.AddWithValue("@asmr_id", asmr_id);
                                        insertCommand.Parameters.AddWithValue("@asmr_order_id", asmr_order_id);

                                        insertCommand.ExecuteNonQuery();
                                    }
                                }
                            }
                        }
                    }
                }
                catch (Exception ex)
                {
                    BeginInvoke((Action)(() =>
                    {
                        Log($"ERROR: {ex}");
                    }));
                    return;
                }
                BeginInvoke((Action)(() =>
                {
                    Log("SUCCESS");
                }));
                if (checkBox3.Checked)
                {
                    Process.Start("explorer.exe", databaseLocation);
                }
            });
        }
        private void CheckBox2_CheckedChanged(object sender, EventArgs e) //תʹԴļλ
        {
            textBox2.Enabled = !checkBox2.Checked;
            button2.Enabled = !checkBox2.Checked;
        }
        private void CheckBox4_CheckedChanged(object sender, EventArgs e) //ļǷ뱣
        {
            textBox3.ReadOnly = !checkBox4.Checked;
        }

        private void TabControl1_SelectedIndexChanged(object sender, EventArgs e) //лǩҳ
        {
            ResetPage2();
            ResetPage4();
            if (tabControl1.SelectedTab == tabPage4)
            {
                RefreshSettingPageInfo();
            }
        }

        private void RefreshSettingPageInfo()  //»ȡP4Ϣ
        {
            Program.config ??= ConfigManager.LoadConfig();
            textBox4.Text = Program.config.DatabaseFilePath;
            textBox5.Text = Program.config.DBBrowserPath;
        }

        private void ResetPage4()
        {
            textBox4.Text = string.Empty;
            textBox5.Text = string.Empty;
        } //ˢP4

        private void ResetPage2()
        {
            // 
            textBox1.Text = string.Empty;
            textBox2.Text = string.Empty;
            textBox3.Text = string.Empty;
            logBox1.Text = string.Empty;

            // ȡѡcheckBox1~4
            checkBox1.Checked = false;
            checkBox2.Checked = false;
            checkBox3.Checked = false;
            checkBox4.Checked = false;
        } //ˢP2

        private void Button7_Click(object sender, EventArgs e) //ȡļ
        {
            Program.config = ConfigManager.LoadConfig();
            RefreshSettingPageInfo();
            MessageBox.Show("Ϣ¼ء", "ʾ", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        private void button8_Click(object sender, EventArgs e) //ļ
        {
            //ǰϢ
            string path1 = textBox4.Text.Trim();
            string path2 = textBox5.Text.Trim();
            if (!string.IsNullOrEmpty(path1) && !File.Exists(path1))
            {
                MessageBox.Show("ָDB·ڡ·Ƿȷ", "", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
            if (!string.IsNullOrEmpty(path2) && !File.Exists(path2))
            {
                MessageBox.Show("ָDB Browser·ڡ·Ƿȷ", "", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }

            //ʼ
            Program.config ??= ConfigManager.LoadConfig();
            Program.config.DatabaseFilePath = path1;
            Program.config.DBBrowserPath = path2;
            ConfigManager.SaveConfig(Program.config);
        }

        private void button9_Click(object sender, EventArgs e) //ļ
        {
            Program.config = null;
            ConfigManager.SaveConfig(new AppConfig());
            RefreshSettingPageInfo();
        }

        private void button4_Click(object sender, EventArgs e) //P4 ļѡ1
        {
            OpenFileDialog openFileDialog1 = new OpenFileDialog();
            openFileDialog1.Title = "ѡȷdbݿļ";
            openFileDialog1.InitialDirectory = Environment.GetFolderPath(Environment.SpecialFolder.Desktop);
            openFileDialog1.Filter = "sqlite dbļ|asmr.db";
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                textBox4.Text = openFileDialog1.FileName;
            }
        }

        private void button5_Click(object sender, EventArgs e)
        {
            OpenFileDialog openFileDialog1 = new OpenFileDialog();
            openFileDialog1.Title = "ѡDB Browser for SQLite";
            openFileDialog1.InitialDirectory = Environment.GetFolderPath(Environment.SpecialFolder.Desktop);
            openFileDialog1.Filter = "DB Browser for SQLite|DB Browser for SQLite.exe";
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                textBox5.Text = openFileDialog1.FileName;
            }
        }

        private void button6_Click(object sender, EventArgs e)
        {
            if(Program.config == null) { Program.config = ConfigManager.LoadConfig(); }
            string db_path = Program.config.DatabaseFilePath;
            string dbb_path = Program.config.DBBrowserPath;
            //·Ƿ
            if (File.Exists(db_path) && File.Exists(dbb_path))
            {
                ProcessStartInfo psi = new ProcessStartInfo
                {
                    FileName = dbb_path,
                    Arguments = db_path
                };

                try
                {
                    Process.Start(psi);
                }
                catch (Exception ex)
                {
                    MessageBox.Show("" + ex.Message, "", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
            else
            {
                MessageBox.Show("ָ·ڡ·Ƿȷ", "", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }
    }
}